# -----------------------------------------------------------------------------
# Programm         : T k T o o l s . p m
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Erstellt         : 12. Februar 2004
# Zuletzt gendert : 12. Februar 2004
# Aufgabe          : Tk Hilfsfunktionen.
# -----------------------------------------------------------------------------

package Graph::GED::TkTools;

use strict;
use warnings;

use Exporter;

#------------------------------------------------------------------------------
# Von Exporter erben:
#------------------------------------------------------------------------------
our @ISA = ('Exporter');
our @EXPORT_OK = qw(
                    anzeige_fenster
                   );

# -----------------------------------------------------------------------------
# Globale private Datei-Variablen:
# -----------------------------------------------------------------------------
my $Debug  = 0;


sub anzeige_fenster ($$$$$;$$$) {
# -----------------------------------------------------------------------------
# sub          : a n z e i g e _ f e n s t e r
# -----------------------------------------------------------------------------
# Autor        : CD
# Aufgabe      : Zeigt etwas in einem Extra-Fenster an.
# Parameter    : Notwendig:
#                  1) Main-Widget
#                  2) Titel
#                  3) Label
#                  4) Font
#                  5) anzuzeigender Text
#                Optional:
#                  6) Modal            (default: 1 = ja   )
#                  7) Breite           (default: 80       )
#                  8) Hhe             (default: 35       )
#                  9) Textfarbe        (default: 'blue'   )
#                 10) Hintergrundfarbe (default: '#d7d7d7')
# Rckgabewert : keiner
# -----------------------------------------------------------------------------
# 0.0.1 - 18.11.2003 - CD - Erstellt
# 0.0.2 - 20.11.2003 - CD - Bindungen fr PageUp, PageDn, Home und End...
#                           Optionale Parameter fr Breite, Hhe, Textfarbe und
#                           Hintergrundfarbe eingebaut.
# 0.0.3 - 04.12.2003 - CD - Verbesserungen: Button in Extraframe, das vor dem
#                           Textfeld gepackt wird, beim Expanden wird die
#                           Zeile mit dem Schalter nicht mehr vergrert.
# 0.0.4 - 08.02.2004 - CD - In ged.pl kopiert und an %Konfig angepasst.
# 0.0.5 - 12.02.2004 - CD - Nach Graph::GED::TkTools verschoben und die Para-
#                           meter Main-Widget und Modal eingebaut.
# -----------------------------------------------------------------------------

    my $mw     = shift;
    my $titel  = shift;
    my $label  = shift;
    my $font   = shift;
    my $text   = shift;
    my $modal  = shift;
       $modal  = 0 unless defined $modal; # damit 0 bergeben werden kann
    my $width  = shift || 80;
    my $height = shift || 35;
    my $tcolor = shift || 'blue';
    my $bcolor = shift || '#d7d7d7';

    print "anzeige_fenster(\n",
          "                Titel : $titel\n",
          "                Label : $label\n",
          "                Font  : $font\n",
          "               )\n"
          if $Debug;


    # -------------------------------------------------------------------------
    # Neues Toplevel-Fenster erzeugen, das den Text anzeigt:
    # -------------------------------------------------------------------------
    my $tl = $mw->Toplevel();
    $tl->title($titel);
    $tl->Label(-text   => $label,
               #-anchor => 'w',
              )
        ->pack(-anchor => 'w');
    my $fr = $tl->Frame()
                 ->pack(-expand => '0',
                        -fill   => 'x',
                        -side   => 'bottom',
                       );
    my $txt = $tl->Scrolled("Text",
                            -scrollbars => 'osoe',
                            -background => $bcolor,
                            -foreground => $tcolor,
                            -state      => 'disabled',
                            -width      => $width,
                            -height     => $height,
                            -relief     => 'flat',
                            -font       => $font,
                            -wrap       => 'none',
                           )
                     ->pack(-side       => 'top',
                            -expand     => 1,
                            -fill       => 'both',
                           );
    my $ok = $fr->Button(-text        => 'OK',
                         -command     => sub {$tl->destroy();
                                              #$Konfig{mw}
                                              #  ->bind('<Escape>', \&beenden);
                                              $mw->focus();
                                             },
                         -default     => 'active',
                         -padx        => 15,
                        )
                  ->pack(-expand      => '0',
                         -fill        => 'none',
                         -side        => 'right',
                        );

    $txt->configure(-state => 'normal');
    $txt->delete('1.0', 'end');
    $txt->insert('end', $text);
    #$txt->insert('end', "\n");
    $txt->configure(-state => 'disabled');

    #
    # Bindungen zum $MW fr Escape lsen und an Lschen dieses Fensters binden.
    # (Beim Beenden des Fensters wird ESC wieder an $MW gebunden (siehe oben).)
    #
    $tl->bind('<Return>', sub{$ok->invoke()});
    #Konfig{mw}->bind ('<Escape>', '');
    $tl->bind('<Escape>', sub{$ok->invoke()});
    #        *$text*->yviewScroll(*number, what*)
    #            This command adjust the view in the window up or down
    #            according to *number* and *what*. *Number* must be an
    #            integer. *What* must be either units or pages. If *what* is
    #            units, the view adjusts up or down by *number* lines on the
    #            display; if it is pages then the view adjusts by *number*
    #            screenfuls. If *number* is negative then earlier positions
    #            in the text become visible; if it is positive then later
    #            positions in the text become visible.
    $txt->bind('<Prior>', sub { $txt->yviewScroll(-1, 'units') } );
    $txt->bind('<Next>',  sub { $txt->yviewScroll( 1, 'units') } );
    #$txt->bind('<Home>',  sub { $txt->see('1.0') } );
    #$txt->bind('<End>',   sub { $txt->see('end') } );
    $txt->bind('<Home>',  sub { $txt->yviewMoveto(0) } );
    $txt->bind('<End>',   sub { $txt->yviewMoveto(1) } );
    # geht beides, unteres wohl etwas schneller
    $txt->bind('<Left>',  sub { $txt->yviewScroll(-1, 'units') } );
    $txt->bind('<Up>',    sub { $txt->yviewScroll(-1, 'units') } );
    $txt->bind('<Right>', sub { $txt->yviewScroll( 1, 'units') } );
    $txt->bind('<Down>',  sub { $txt->yviewScroll( 1, 'units') } );
    # irgendwas stimmt noch nicht ganz... da mssen eingebaute Funktionalitten
    # mit reinspielen...

    #$txt->bind('<F9>',    sub { $txt->yviewScroll(-1, 'units') } );
    #$txt->bind('<F10>',   sub { $txt->yviewScroll( 1, 'units') } );
    #$txt->bind('<F5>',    sub { $txt->yviewScroll(-1, 'pages') } );
    #$txt->bind('<F6>',    sub { $txt->yviewScroll( 1, 'pages') } );

    #
    # Rest:
    # (grab verhindert das zurckschalten auf $WM per Klick, focus sorgt dafr,
    # dass $tl auch wirklich aktiv ist.)
    #
    $tl->grab() if $modal;
    $tl->focus();
    $txt->focus(); # ?
} # sub anzeige_fenster


return 1;

__END__

=head1 NAME

Graphen::GED::TkTools.pm - a module with a few tools for Tk

=head1 COPYRIGHT


Copyright 2004 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
